sub makedb {			# Make our local database
    unlink "${DBName}.dir";
    unlink "${DBName}.pag";
    unlink "${MAPName}";
    dbmopen(LOOKUP, "$DBName",0644) || die "Could not create dbm file";
    open(OFFSET, ">$MAPName") || die "Could not create file";
    unshift(@ARGV, '-') if $#ARGV < 0;
    while ($ARGV = shift @ARGV) {
	$ARGV=~s/.*\/(.*)$/\1/;
	print "Indexing $ARGV...\n";
	&IndexFile("$ARGV");
    }
    &flushindex;
}

sub IndexFile {			# Index a local file
    local($DataFile)=@_;
    $offset=$tmpoffset=0;
    open(RAWDATA, "$DBDIR/$DataFile") || die "Could not open data file";
    while (<RAWDATA>) {
	tr/A-Z/a-z/;
	if (!/^$/) {
	    if ($newrecord==1) {
		$newrecord=0;
		$offset=$tmpoffset;
	    }	
	    $tmpoffset = $tmpoffset + length;
	    chop;
	    s/[,\"]/ /g;
	    s/[ ]+/ /g;
	    if (/^[ \t]/) {
		$value=$_;
	    } else {
		($field,$value) = split (/:/,$_);
		$template=$value if ($field eq "template-type");
		&addwordtoindex($field,$template,"attribute",$DataFile,$offset);
	    } 
	    foreach $curval (split(/ /,$value)) {
		next if (length($curval) <= 1);
		&addwordtoindex($curval, $template, $field,$DataFile,$offset);
	    }
	} else {
	    $newrecord=1;
	    $tmpoffset++;
	}
    }
}

sub addwordtoindex {
    local ($word, $template, $field,$file,$offset) = @_;
    $word =~ s/[ \t]//g;
    $string="$template,$field,$file,$offset";
    $string =~ s/[ \t]//g;
    if (defined $words{$word}) {
	$words{$word}.="|$string";
    } else {
	$words{$word}="$word:$string";
    }
}

sub flushindex {		# Write local indexes to disk
    print "Writing to disk...\n";
    while (($a,$b) = (each %words)) {
	print OFFSET "$b\n";
	$LOOKUP{$a}=$counter++;
	delete $words{$a};
    }
}

1
